【SCOI 2010】股票交易
题目
最近 \(\text{lxhgww}\) 又迷上了投资股票,通过一段时间的观察和学习,他总结出了股票行情的一些规律。
通过一段时间的观察,\(\text{lxhgww}\) 预测到了未来 \(T\) 天内某只股票的走势,第 \(i\) 天的股票买入价为每股 \(ap_i\),第 \(i\) 天的股票卖出价为每股 \(bp_i\)(数据保证对于每个 \(i\),都有 \(ap_i \geq bp_i\)),但是每天不能无限制地交易,于是股票交易所规定第 \(i\) 天的一次买入至多只能购买 \(as_i\) 股,一次卖出至多只能卖出 \(bs_i\) 股。
另外,股票交易所还制定了两个规定。为了避免大家疯狂交易,股票交易所规定在两次交易(某一天的买入或者卖出均算是一次交易)之间,至少要间隔 \(w\) 天,也就是说如果在第 \(i\) 天发生了交易,那么从第 \(i + 1\) 天到第 \(i + w\) 天,均不能发生交易。同时,为了避免垄断,股票交易所还规定在任何时间,一个人的手里的股票数不能超过 \(\text{MaxP}\)。
在第 \(1\) 天之前,\(\text{lxhgww}\) 手里有一大笔钱(可以认为钱的数目无限),但是没有任何股票,当然,\(T\) 天以后,\(\text{lxhgww}\) 想要赚到最多的钱,聪明的程序员们,你们能帮助他吗?
分析
设 \(f(i,j)\) 代表第 \(i\) 持有 \(j\) 股的最大收益。
\max_{k = 1}^{as_i} f(i - w - 1,j - k) - ap_i\times k \\
\max_{k = 1}^{bs_i} f(i - w - 1,j + k) + bp_i\times k \\
f(i - 1,j)
\end{array} \right.
\]
很容易得出,该方程的时间复杂度为 \(\Theta (n^3)\)。显然会\(\rm T\)。
以只买入的 \(\max_{k = 1}^{as_i} f(i - w - 1,j - k) - ap_i\times k\) 看,我们发现我们要查询的 \(f\) 总是一段连续的区间,但是若使用单调队列维护 \(f\) ,\(ap_i\times k\) 又很恶心。
但是我们通过观察,对于每个 \(ap_i\times k\) 和 \(bp_i \times k\) 所影响到的要查询的 \(f\) ,若 \(j + 1\) ,则它们都会同时加上 \(ap_i\) 或 \(-bp_i\)。
比如原先的 \(f(i - w - 1, j) - ap_i,\ f(i - w - 1, j - 1) - 2ap_i,\cdots,f(i - w - 1, j + k) - ap_i\times k\)。
当区间右移一次时,它们的影响变成了:$f(i - w - 1, j - 1) - ap_i,\ f(i - w - 1, j - 2) - 2ap_i,\cdots $
所以,当要查询的区间右移一次时,它们的相对大小关系是不会改变的,我们可以对原 \(\rm dp\) 式进行变换来更好的运用这个性质。
以买入为例,\(\max_{k = 1}^{as_i} f(i - w - 1,j - k) - ap_i\times k\),若令 \(p = j - k\),则变为:
& \max_{p = j - 1}^{j - as_i} f(i - w - 1,p) - ap_i\times (j - p) \\
= & \max_{p = j - 1}^{j - as_i} ( f(i - w - 1,p) + ap_i\times p ) - ap_i\times j
\end{array}
\]
这么一来,\(f\) 与 \(ap_i\) 就有了一一对应的关系,可以很容易的利用单调队列优化。
同理,卖出也可以这样处理,变式为 \(\max_{p = j + 1}^{j + bs_i} (f(i - w - 1,p) + bp_i\times p) - bp_i\times j\)。
接下来就是常规的单调队列优化,时间复杂度为 \(\Theta (n ^ 2)\)。
代码
#include <bits/stdc++.h>
using namespace std;
const int MAXN = 2000 + 5, inf = 0x3f3f3f3f;
int f[MAXN][MAXN], ap[MAXN], bp[MAXN], as[MAXN], bs[MAXN], w, t, maxp;
struct monQue {
pair<int, int> data[MAXN];
int head, tail;
void clear() {head = 0, tail = 0;}
bool empty() {return tail <= head;}
void push(pair<int, int> x) {
while(!empty() && data[tail - 1] <= x) tail--;
data[tail++] = x;
}
void pop() {head++;}
pair<int, int> front() {return data[head];}
} sell, buy;
int main() {
memset(f, ~0x3f, sizeof(f));
scanf("%d%d%d", &t, &maxp, &w);
for(int i = 1; i <= t; i++)
scanf("%d%d%d%d", &ap[i], &bp[i], &as[i], &bs[i]);
for(int i = 1; i <= t; i++) {
buy.clear(); sell.clear();
for(int j = 0; j <= maxp; j++) {
f[i][j] = max(f[i - 1][j], f[i][j]);
if(j <= as[i]) f[i][j] = max(-ap[i] * j, f[i][j]);
if(i - w - 1 <= 0) continue;
if(j) {
while(!buy.empty() && buy.front().second < j - as[i]) buy.pop();
buy.push(make_pair(f[i - w - 1][j - 1] + ap[i] * (j - 1), j - 1));
f[i][j] = max(buy.front().first - ap[i] * j, f[i][j]);
}
}
if(i - w - 1 <= 0) continue;
for(int j = maxp - 1; j >= 0; j--) {
while(!sell.empty() && sell.front().second > j + bs[i]) sell.pop();
sell.push(make_pair(f[i - w - 1][j + 1] + bp[i] * (j + 1), j + 1));
f[i][j] = max(sell.front().first - bp[i] * j, f[i][j]);
}
}
int ans = -inf;
for(int i = 0; i <= maxp; i++) {
ans = max(f[t][i], ans);
}
printf("%d\n", ans);
return 0;
}
后记
终于把这个坑填上了。。
【SCOI 2010】股票交易的更多相关文章
- [SCOI 2010] 股票交易
[题目链接] https://www.lydsy.com/JudgeOnline/problem.php?id=1855 [算法] 单调队列优化动态规划 [代码] #include<bits/s ...
- SCOI 2010 连续攻击游戏(贪心,图论)
SCOI 2010 连续攻击游戏 solution 直接就硬刚 我愿称贪心为暴力 因为题目中要求一定从小到大贪心,那么当前点的下标有能够选取的较大点,那么它一定可以和前面的一个较小点连接,所以可以直接 ...
- 【BZOJ 1857】【SCOI 2010】传送带
三分套三分,虽然简单,但是也得掌握,,, 时间复杂度$O(log_{1.5}^2 n)$ 一开始WA好几次发现是快速读入里没有return,这样也能过样例?_(:3J∠)_ #include<c ...
- SCOI 2010 序列操作
题目描述 lxhgww最近收到了一个01序列,序列里面包含了n个数,这些数要么是0,要么是1,现在对于这个序列有五种变换操作和询问操作: 0 a b 把[a, b]区间内的所有数全变成0 1 a b ...
- [SCOI 2010]传送带
Description 题库链接 在一个 \(2\) 维平面上有两条传送带,每一条传送带可以看成是一条线段.两条传送带分别为线段 \(AB\) 和线段 \(CD\) .在 \(AB\) 上的移动速度为 ...
- [SCOI 2010]字符串
Description lxhgww最近接到了一个生成字符串的任务,任务需要他把n个1和m个0组成字符串,但是任务还要求在组成的字符串中,在任意的前k个字符中,1的个数不能少于0的个数.现在lxhgw ...
- 解题:SCOI 2010 序列操作
题面 线段树......模板题(雾? 然而两种标记会互相影响,必须保证每次只放一个(不然就不知道怎么放了),具体的影响就是: 翻转标记会使得覆盖标记一起翻转,下放的时候就是各种swap 覆盖标记会抹掉 ...
- Scoi 2010 幸运数字
[题目描述]在中国,很多人都把6和8视为是幸运数字!lxhgww也这样认为,于是他定义自己的“幸运号码”是十进制表示中只包含数字6和8的那些号码,比如68,666,888都是“幸运号码”!但是这种“幸 ...
- 【SCOI 2010】传送带
为了方便,我们不妨设$\rm P \lt Q,R$ 我们发现,有$\rm E$点在$\rm AB$上,$\rm F$点在$\rm CD$上,最优解一定是$\rm AE\rightarrow EF\ri ...
随机推荐
- WPF中的StackPanel、WrapPanel、DockPanel(转)
一.StackPanel StackPanel是以堆叠的方式显示其中的控件 1.可以使用Orientation属性更改堆叠的顺序 Orientation="Vertical" 默认 ...
- C#调用Python脚本并使用Python的第三方模块
[转载]http://zh.5long.me/2015/dotnet-call-python/ 前言 InronPython是一种在.NET和Mono上实现的Python语言,使用InronPytho ...
- 无法通过CTRL+空格及SHIFT+CTRL调出输入法的解决方案
打开任务管理器: 运行:CTFMON.EXE
- 测试发布(maven-assembly-plugin看好你哦)
项目改成了maven管理,现场需要用增量补丁包的形式发布代码: 2015/4/21 以前试过用ant打补丁包,现在试试maven能不能做同样的事情: maven-assembly-plugin看着可以 ...
- UVALive 3530 Martian Mining(贪心,dp)
分析: 对于网格grid[i][j]如果放向上的管道,那么grid[i][k], k>j 就只能放向上的管道了. 那么定义dp[i][j]表示第i行,最后一个放向左的管道是j的最大总矿量. j ...
- hdu-1556 Color the ball---树状数组+区间修改单点查询
题目链接: http://acm.hdu.edu.cn/showproblem.php?pid=1556 题目大意: Problem Description N个气球排成一排,从左到右依次编号为1,2 ...
- Android(java)学习笔记100:使用Dexdump等工具进行反编译
使用Dex等工具进行反编译步骤: (1)首先找到Android软件安装包中的class.dex,把APK文件改名为".zip",然后解压缩其中的class.dex文件,这是Java ...
- 快速开发一个PHP扩展
快速开发一个PHP扩展 作者:heiyeluren时间:2008-12-5博客:http://blog.csdn.net/heiyeshuwu 本文通过非常快速的方式讲解了如何制作一个PHP 5.2 ...
- python剑指offer系列二叉树中和为某一值的路径
题目描述 输入一颗二叉树的跟节点和一个整数,打印出二叉树中结点值的和为输入整数的所有路径.路径定义为从树的根结点开始往下一直到叶结点所经过的结点形成一条路径.(注意: 在返回值的list中,数组长度大 ...
- 通过cmd查看环境变量名对应的环境变量值
在VS环境中通常要添加路径,不过基本都是按照往上提供的方法添加变量名形如:$(VC_IncludePath),但是如何通过cmd命令找到真正的路径呢 未完待续……